package com.company.tour.app;

import com.company.tour.entity.Tour;
import com.company.tour.entity.Vehicle;
import io.jmix.core.DataManager;
import io.jmix.maps.utils.GeometryUtils;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class VehiclesService {

    private final DataManager dataManager;

    public VehiclesService(DataManager dataManager) {
        this.dataManager = dataManager;
    }

    public List<Vehicle> loadVehicles() {
        Vehicle vehicle = dataManager.create(Vehicle.class);
        vehicle.setName("Vehicle 1");
        vehicle.setPoint(GeometryUtils.createPoint(13.385959682568695, 52.51596234647903));
        vehicle.setTour(dataManager.load(Tour.class)
                .query("where e.name = 'First tour'")
                .one());

        Vehicle vehicle2 = dataManager.create(Vehicle.class);
        vehicle2.setName("Vehicle 2");
        vehicle2.setPoint(GeometryUtils.createPoint(13.393418302102418, 52.5126468760605));
        vehicle2.setTour(dataManager.load(Tour.class)
                .query("where e.name = 'Second tour'")
                .one());

        return List.of(vehicle, vehicle2);
    }
}