package com.company.tour.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.maps.Geometry;
import jakarta.persistence.*;
import org.locationtech.jts.geom.LineString;

import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "TOUR")
@Entity
public class Tour {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @InstanceName
    @Column(name = "NAME")
    private String name;

    @Column(name = "ROUTE")
    @Geometry
    private LineString route;

    @JoinTable(name = "TOUR_TOUR_STOP_LINK",
            joinColumns = @JoinColumn(name = "TOUR_ID"),
            inverseJoinColumns = @JoinColumn(name = "TOUR_STOP_ID"))
    @ManyToMany
    private List<TourStop> stops;

    public List<TourStop> getStops() {
        return stops;
    }

    public void setStops(List<TourStop> stops) {
        this.stops = stops;
    }

    public LineString getRoute() {
        return route;
    }

    public void setRoute(LineString route) {
        this.route = route;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}