package com.company.tour.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.maps.Geometry;
import jakarta.persistence.*;
import org.locationtech.jts.geom.Point;

import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "TOUR_STOP")
@Entity
public class TourStop {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @InstanceName
    @Column(name = "NAME")
    private String name;

    @Column(name = "POINT")
    @Geometry
    private Point point;

    @JoinTable(name = "TOUR_TOUR_STOP_LINK",
            joinColumns = @JoinColumn(name = "TOUR_STOP_ID", referencedColumnName = "ID"),
            inverseJoinColumns = @JoinColumn(name = "TOUR_ID", referencedColumnName = "ID"))
    @ManyToMany
    private List<Tour> tours;

    public List<Tour> getTours() {
        return tours;
    }

    public void setTours(List<Tour> tours) {
        this.tours = tours;
    }

    public Point getPoint() {
        return point;
    }

    public void setPoint(Point point) {
        this.point = point;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}